/************************************************
* EF.C - error filter: Scan a text file, and	*
* output all Microsoft style error messages.	*
*												*
* 900531 MCMason - written in MSC v5.1			*
************************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#define TRUE  (1==1)
#define FALSE (1==0)

char	workspc[512];	 /* line input buffer	*/
int		WarnFl = TRUE,	 /* Display warnings?	*/
		ErrorFl= TRUE;	 /* Display errors?		*/
FILE	*InFile=stdin,	 /* Source stream		*/
		*OutFile=stdout; /* Destination stream	*/

void main(int argc, char *argv[])
	{
	char	*t;
	int		i, j, BadArg, ShowLine;

	/* parse the command line */
	for (BadArg=FALSE, i=1; i<argc; i++)
		/* Disable Error or Warnings output? */
		if ((argv[i][0]=='-')||(argv[i][0]=='\\'))
			{
			for (j=1; argv[i][j]; j++)
				if (toupper(argv[i][1])=='E')
					ErrorFl=FALSE;
				else if (toupper(argv[i][1])=='W')
					WarnFl=FALSE;
				else
					fprintf(stderr,"Unknown switch"
							"character '%c' ignored",
							argv[i][j]);
			}
		/* Specify input file? */
		else if (InFile==stdin)
			{
			InFile=fopen(argv[i],"r");
			if (InFile == NULL)
				{
				fprintf(stderr,"Can't open %s for"
						" input\n",argv[i]);
				exit(1);
				}
			}
		/* Specify output file? */
		else if (OutFile==stdout)
			{
			OutFile=fopen(argv[i],"w");
			if (OutFile == NULL)
				{
				fprintf(stderr,"Can't open %s for"
						" output",argv[i]);
				exit(1);
				}
			}
		/* Hmmm, too many filenames */
		else
			fprintf(stderr,"The input and output "
					"files are already selected, "
					"%s not needed.\n\7",argv[i]);

	/* Process each line! */
	while (!feof(InFile))
		{
		fgets(workspc,510,InFile);
		ShowLine = FALSE;

		/* Check for warning */
		if ((t=strstr(workspc,"warning")) != NULL)
			if (isdigit(t[9])  && isdigit(t[10]) &&
				isdigit(t[11]) && isdigit(t[12]) &&
				isupper(t[8])  && WarnFl)
					ShowLine = TRUE;

		/* Check for error */
		if ((t=strstr(workspc,"error")) != NULL)
			if (isdigit(t[7]) && isdigit(t[8]) &&
				isdigit(t[9]) && isdigit(t[10]) &&
				isupper(t[6]) && ErrorFl)
					ShowLine = TRUE;

		/* Output the line if flagged */
		if (ShowLine)
			fputs(workspc,OutFile);
		}
	}
